/*
 * Copyright (C) 1997 and 1998 WIDE Project.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *    This product includes software developed by WIDE Project and
 *    its contributors.
 * 4. Neither the name of the project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

void start_daemon(void);
void sig_child(int);
void sig_terminate(int);
void play_child(int, struct in6_addr *, const char *);
void tcp_relay(int, int, const char *);
void ftp_relay(int, int);
int  ftp_active(int, int, int *, int *);
int  ftp_passive(int, int, int *, int *);
void rsh_relay(int, int);
void rsh_dual_relay(int, int);
void exit_error(const char *fmt, ...);
void exit_success(const char *fmt, ...);
void exit_failure(const char *fmt, ...);

#define DEFAULT_PORT_NAME "telnet"
#define DEFAULT_PATH "/usr/local/v6/libexec/telnetd"
#define DEFAULT_NAME "telnetd"

#define FTP_PORT	21
#define RLOGIN_PORT	513
#define RSH_PORT	514

#define RETURN_SUCCESS	0
#define RETURN_FAILURE	1

#define YES	1
#define NO	0

#define MSS	2048
#define MAXARGV 20

#define NUMPRT 1
#define NUMPRG 2
#define NUMARG 3

#define	UC(b)	(((int)b)&0xff)

#define ERRSTR sys_errlist[errno]
