struct sockaddr6 {
	union {
		struct sockaddr su_sin;
		struct sockaddr_in su_sin4;
		struct sockaddr_in6 su_sin6;
	} sa6_un;
};

#define sa6_sin		sa6_un.su_sin
#define sa6_sin4	sa6_un.su_sin4
#define sa6_sin6	sa6_un.su_sin6
#define sa6_len		sa6_un.su_sin.sa_len
#define sa6_family	sa6_un.su_sin.sa_family

#define SA6_EQ4(x,y) (((x).sa6_sin4.sin_port == (y).sa6_sin4.sin_port) && \
		 ((x).sa6_sin4.sin_addr.s_addr == (y).sa6_sin4.sin_addr.s_addr))
#define SA6_EQ6(x, y) (((x).sa6_sin6.sin6_port == (y).sa6_sin6.sin6_port) && \
			IN6_ARE_ADDR_EQUAL(&(x).sa6_sin6.sin6_addr, \
					   &(y).sa6_sin6.sin6_addr))
#define SA6_EQUAL(x,y)  (((x).sa6_family == (y).sa6_family) && \
			((x).sa6_family == AF_INET) ? \
			 SA6_EQ4((x), (y)) : SA6_EQ6((x), (y)))

#define SA6_ADDR(x)	(((x).sa6_family == AF_INET) ? \
			 (void *)&((x).sa6_sin4.sin_addr) : \
			 (void *)&((x).sa6_sin6.sin6_addr))
#define SA6_NTOP(x,y,z)	inet_ntop((x).sa6_family, SA6_ADDR(x), (y), (z))
